package logic

import (
	"GtDataStore/app/cmd/organization/internal/svc"
	"GtDataStore/app/cmd/organization/pb"
	"GtDataStore/common/xerr"
	"context"
	"github.com/pkg/errors"
	"github.com/zeromicro/go-zero/core/logx"
)

type MultiAddItemHistoryDataLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewMultiAddItemHistoryDataLogic(ctx context.Context, svcCtx *svc.ServiceContext) *MultiAddItemHistoryDataLogic {
	return &MultiAddItemHistoryDataLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *MultiAddItemHistoryDataLogic) MultiAddItemHistoryData(in *pb.MultiAddItemHistoryDataReq) (*pb.MultiAddItemHistoryDataResp, error) {
	_, err := l.svcCtx.ItemHistoryData.MultiInsert(l.ctx, in.ProjectId, in.List)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrCode(xerr.DB_ERROR), "item history data table multi Insert err:%v", err)
	}
	return &pb.MultiAddItemHistoryDataResp{}, nil
}
