package svc

import (
	"GtDataStore/app/model"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

type modelList struct {
	DeviceBind      model.DcDeviceBindModel
	ProjectConfig   model.DcProjectConfigModel
	WorkingUf       model.DcWorkingUfModel
	WorkingMf       model.DcWorkingMfModel
	WorkingNf       model.DcWorkingNfModel
	WorkingRo       model.DcWorkingRoModel
	WorkingPump     model.DcWorkingPumpModel
	WorkingValve    model.DcWorkingValveModel
	WorkingChest    model.DcWorkingChestModel
	ItemHistoryData model.DcItemHistoryDataModel
}

func initModel(svc *ServiceContext) {
	mysql := sqlx.NewMysql(svc.Config.DtDataStoreDB.DataSource)
	svc.DeviceBind = model.NewDcDeviceBindModel(mysql)
	svc.ProjectConfig = model.NewDcProjectConfigModel(mysql)
	svc.WorkingUf = model.NewDcWorkingUfModel(mysql)
	svc.WorkingMf = model.NewDcWorkingMfModel(mysql)
	svc.WorkingNf = model.NewDcWorkingNfModel(mysql)
	svc.WorkingRo = model.NewDcWorkingRoModel(mysql)
	svc.WorkingPump = model.NewDcWorkingPumpModel(mysql)
	svc.WorkingChest = model.NewDcWorkingChestModel(mysql)
	svc.WorkingValve = model.NewDcWorkingValveModel(mysql)
	svc.ItemHistoryData = model.NewDcItemHistoryDataModel(mysql)
}
