// Code generated by goctl. DO NOT EDIT.

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"
	"time"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	dcCleanBindFieldNames          = builder.RawFieldNames(&DcCleanBind{})
	dcCleanBindRows                = strings.Join(dcCleanBindFieldNames, ",")
	dcCleanBindRowsExpectAutoSet   = strings.Join(stringx.Remove(dcCleanBindFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	dcCleanBindRowsWithPlaceHolder = strings.Join(stringx.Remove(dcCleanBindFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"
)

type (
	dcCleanBindModel interface {
		Insert(ctx context.Context, data *DcCleanBind) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*DcCleanBind, error)
		FindOneByProjectIdItem(ctx context.Context, projectId int64, item string) (*DcCleanBind, error)
		Update(ctx context.Context, data *DcCleanBind) error
		Delete(ctx context.Context, id int64) error
	}

	defaultDcCleanBindModel struct {
		conn  sqlx.SqlConn
		table string
	}

	DcCleanBind struct {
		Id           int64     `db:"id"`
		ProjectId    int64     `db:"project_id"`
		DeviceCode   string    `db:"device_code"`
		Item         string    `db:"item"`
		RangeNa      string    `db:"range_na"`      // 被当做 na 的值范围，使用逗号分隔多个值 例： '''', ''-'', ''null
		Dropna       int64     `db:"dropna"`        // 为 na 时，是否进行删除操作 0： 否 1： 是
		Fillna       int64     `db:"fillna"`        // 为 na 时，是否进行数据填充 0:  否 1： 是
		FillnaWay    string    `db:"fillna_way"`    // 当 fillna 为 1 时， 为数据指定填充方式 【默认值 ｜ 中位数 ｜ 众数 ｜ 平均数 ｜ 自定义】
		DropSolitude int64     `db:"drop_solitude"` // 是否删除离群点
		Duplicate    int64     `db:"duplicate"`     // 是否进行去重复操作 0:  否 1： 是
		CTime        time.Time `db:"c_time"`
	}
)

func newDcCleanBindModel(conn sqlx.SqlConn) *defaultDcCleanBindModel {
	return &defaultDcCleanBindModel{
		conn:  conn,
		table: "`dc_clean_bind`",
	}
}

func (m *defaultDcCleanBindModel) withSession(session sqlx.Session) *defaultDcCleanBindModel {
	return &defaultDcCleanBindModel{
		conn:  sqlx.NewSqlConnFromSession(session),
		table: "`dc_clean_bind`",
	}
}

func (m *defaultDcCleanBindModel) Delete(ctx context.Context, id int64) error {
	query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
	_, err := m.conn.ExecCtx(ctx, query, id)
	return err
}

func (m *defaultDcCleanBindModel) FindOne(ctx context.Context, id int64) (*DcCleanBind, error) {
	query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", dcCleanBindRows, m.table)
	var resp DcCleanBind
	err := m.conn.QueryRowCtx(ctx, &resp, query, id)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultDcCleanBindModel) FindOneByProjectIdItem(ctx context.Context, projectId int64, item string) (*DcCleanBind, error) {
	var resp DcCleanBind
	query := fmt.Sprintf("select %s from %s where `project_id` = ? and `item` = ? limit 1", dcCleanBindRows, m.table)
	err := m.conn.QueryRowCtx(ctx, &resp, query, projectId, item)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultDcCleanBindModel) Insert(ctx context.Context, data *DcCleanBind) (sql.Result, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", m.table, dcCleanBindRowsExpectAutoSet)
	ret, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.DeviceCode, data.Item, data.RangeNa, data.Dropna, data.Fillna, data.FillnaWay, data.DropSolitude, data.Duplicate, data.CTime)
	return ret, err
}

func (m *defaultDcCleanBindModel) Update(ctx context.Context, newData *DcCleanBind) error {
	query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, dcCleanBindRowsWithPlaceHolder)
	_, err := m.conn.ExecCtx(ctx, query, newData.ProjectId, newData.DeviceCode, newData.Item, newData.RangeNa, newData.Dropna, newData.Fillna, newData.FillnaWay, newData.DropSolitude, newData.Duplicate, newData.CTime, newData.Id)
	return err
}

func (m *defaultDcCleanBindModel) tableName() string {
	return m.table
}
