// Code generated by goctl. DO NOT EDIT.

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"
	"time"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	dcProjectConfigFieldNames          = builder.RawFieldNames(&DcProjectConfig{})
	dcProjectConfigRows                = strings.Join(dcProjectConfigFieldNames, ",")
	dcProjectConfigRowsExpectAutoSet   = strings.Join(stringx.Remove(dcProjectConfigFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	dcProjectConfigRowsWithPlaceHolder = strings.Join(stringx.Remove(dcProjectConfigFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"
)

type (
	dcProjectConfigModel interface {
		FindAll(ctx context.Context) ([]DcProjectConfig, error)
		FindAllByPage(ctx context.Context, offset, limit int64) ([]DcProjectConfig, error)
		Insert(ctx context.Context, data *DcProjectConfig) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*DcProjectConfig, error)
		FindOneByProjectId(ctx context.Context, projectId int64) (*DcProjectConfig, error)
		Update(ctx context.Context, data *DcProjectConfig) error
		Delete(ctx context.Context, id int64) error
	}

	defaultDcProjectConfigModel struct {
		conn  sqlx.SqlConn
		table string
	}

	DcProjectConfig struct {
		Id          int64       `db:"id"`
		ProjectId   int64       `db:"project_id"`
		Technologys Technologys `db:"technologys"` // 该项目中要使用的项目 ["A","B"]
		Status      int64       `db:"status"`      // 项目状态  0：禁用 1： 正常
		MTime       time.Time   `db:"m_time"`
	}
)

func newDcProjectConfigModel(conn sqlx.SqlConn) *defaultDcProjectConfigModel {
	return &defaultDcProjectConfigModel{
		conn:  conn,
		table: "`dc_project_config`",
	}
}

func (m *defaultDcProjectConfigModel) withSession(session sqlx.Session) *defaultDcProjectConfigModel {
	return &defaultDcProjectConfigModel{
		conn:  sqlx.NewSqlConnFromSession(session),
		table: "`dc_project_config`",
	}
}

func (m *defaultDcProjectConfigModel) FindAllByPage(ctx context.Context, offset, limit int64) ([]DcProjectConfig, error) {
	var resp []DcProjectConfig
	query := fmt.Sprintf("select %s from %s where `status`=1 order by id desc limit %d, %d", dcProjectConfigRows, m.table, offset, limit)
	err := m.conn.QueryRowsCtx(ctx, &resp, query)
	switch err {
	case nil:
		return resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultDcProjectConfigModel) Delete(ctx context.Context, id int64) error {
	query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
	_, err := m.conn.ExecCtx(ctx, query, id)
	return err
}

func (m *defaultDcProjectConfigModel) FindOne(ctx context.Context, id int64) (*DcProjectConfig, error) {
	query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", dcProjectConfigRows, m.table)
	var resp DcProjectConfig
	err := m.conn.QueryRowCtx(ctx, &resp, query, id)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultDcProjectConfigModel) FindOneByProjectId(ctx context.Context, projectId int64) (*DcProjectConfig, error) {
	var resp DcProjectConfig
	query := fmt.Sprintf("select %s from %s where `project_id` = ? limit 1", dcProjectConfigRows, m.table)
	err := m.conn.QueryRowCtx(ctx, &resp, query, projectId)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultDcProjectConfigModel) FindAll(ctx context.Context) ([]DcProjectConfig, error) {
	var resp []DcProjectConfig
	query := fmt.Sprintf("select %s from %s", dcProjectConfigRows, m.table)
	err := m.conn.QueryRowsCtx(ctx, &resp, query)
	switch err {
	case nil:
		return resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultDcProjectConfigModel) Insert(ctx context.Context, data *DcProjectConfig) (sql.Result, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?)", m.table, dcProjectConfigRowsExpectAutoSet)
	ret, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.Technologys, data.Status, data.MTime)
	return ret, err
}

func (m *defaultDcProjectConfigModel) Update(ctx context.Context, newData *DcProjectConfig) error {
	query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, dcProjectConfigRowsWithPlaceHolder)
	_, err := m.conn.ExecCtx(ctx, query, newData.ProjectId, newData.Technologys, newData.Status, newData.MTime, newData.Id)
	return err
}

func (c *DcProjectConfig) IsEnabled() bool {
	return c.Status == 1
}

func (m *defaultDcProjectConfigModel) tableName() string {
	return m.table
}
